# Object Instance `luci.ip.cidr`

IP CIDR Object. Represents an IPv4 or IPv6 address range.

## Functions

cidr:is4 () | Checks whether the CIDR instance is an IPv4 address range
cidr:is4rfc1918 () | Checks whether the CIDR instance is within the private RFC1918 address space
cidr:is4linklocal () | Checks whether the CIDR instance is an IPv4 link local (Zeroconf) address
cidr:is6 () | Checks whether the CIDR instance is an IPv6 address range
cidr:is6linklocal () | Checks whether the CIDR instance is an IPv6 link local address
cidr:is6mapped4 () | Checks whether the CIDR instance is an IPv6 mapped IPv4 address
cidr:ismac () | Checks whether the CIDR instance is an ethernet MAC address range
cidr:ismaclocal () | Checks whether the CIDR instance is a locally administered (LAA) MAC address
cidr:ismacmcast () | Checks whether the CIDR instance is a multicast MAC address
cidr:lower (addr) | Checks whether this CIDR instance is lower than the given argument.
cidr:higher (addr) | Checks whether this CIDR instance is higher than the given argument.
cidr:equal (addr) | Checks whether this CIDR instance is equal to the given argument.
cidr:prefix (mask) | Get or set prefix size of CIDR instance.
cidr:network (mask) | Derive network address of CIDR instance.
cidr:host () | Derive host address of CIDR instance.
cidr:mask (mask) | Derive netmask of CIDR instance.
cidr:broadcast (mask) | Derive broadcast address of CIDR instance.
cidr:mapped4 () | Derive mapped IPv4 address of CIDR instance.
cidr:tomac () | Derive MAC address of IPv6 link local CIDR instance.
cidr:tolinklocal () | Derive IPv6 link local address from MAC address CIDR instance.
cidr:contains (addr) | Test whether CIDR contains given range.
cidr:add (amount, inplace) | Add given amount to CIDR instance.
cidr:sub (amount, inplace) | Subtract given amount from CIDR instance.
cidr:minhost () | Calculate the lowest possible host address within this CIDR instance.
cidr:maxhost () | Calculate the highest possible host address within this CIDR instance.
cidr:string () | Convert CIDR instance into string representation.

## Functions

cidr:is4 ()
  Checks whether the CIDR instance is an IPv4 address range

  ### Return value:

  `true` if the CIDR is an IPv4 range, else `false`

  ### See also:

  - cidr:is6
  - cidr:ismac
cidr:is4rfc1918 ()
  Checks whether the CIDR instance is within the private RFC1918 address space

  ### Usage:

      local addr = luci.ip.new("192.168.45.2/24")
      if addr:is4rfc1918() then
      	print("Is a private address")
      end

  ### Return value:

  `true` if the entire range of this CIDR lies within one of the ranges `10.0.0.0-10.255.255.255`, `172.16.0.0-172.31.0.0` or `192.168.0.0-192.168.255.255`, else `false`.
cidr:is4linklocal ()
  Checks whether the CIDR instance is an IPv4 link local (Zeroconf) address

  ### Usage:

      local addr = luci.ip.new("169.254.34.125")
      if addr:is4linklocal() then
      	print("Is a zeroconf address")
      end

  ### Return value:

  `true` if the entire range of this CIDR lies within the range the range `169.254.0.0-169.254.255.255`, else `false`.
cidr:is6 ()
  Checks whether the CIDR instance is an IPv6 address range

  ### Return value:

  `true` if the CIDR is an IPv6 range, else `false`

  ### See also:

  - cidr:is4
  - cidr:ismac
cidr:is6linklocal ()
  Checks whether the CIDR instance is an IPv6 link local address

  ### Usage:

      local addr = luci.ip.new("fe92:53a:3216:af01:221:63ff:fe75:aa17/64")
      if addr:is6linklocal() then
      	print("Is a linklocal address")
      end

  ### Return value:

  `true` if the entire range of this CIDR lies within the range the `fe80::/10` range, else `false`.
cidr:is6mapped4 ()
  Checks whether the CIDR instance is an IPv6 mapped IPv4 address

  ### Usage:

      local addr = luci.ip.new("::ffff:192.168.1.1")
      if addr:is6mapped4() then
      	print("Is a mapped IPv4 address")
      end

  ### Return value:

  `true` if the address is an IPv6 mapped IPv4 address in the form `::ffff:1.2.3.4`.
cidr:ismac ()
  Checks whether the CIDR instance is an ethernet MAC address range

  ### Return value:

  `true` if the CIDR is a MAC address range, else `false`

  ### See also:

  - cidr:is4
  - cidr:is6
cidr:ismaclocal ()
  Checks whether the CIDR instance is a locally administered (LAA) MAC address

  ### Usage:

      local mac = luci.ip.new("02:C0:FF:EE:00:01")
      if mac:ismaclocal() then
        print("Is an LAA MAC address")
      end

  ### Return value:

  `true` if the MAC address sets the locally administered bit.
cidr:ismacmcast ()
  Checks whether the CIDR instance is a multicast MAC address

  ### Usage:

      local mac = luci.ip.new("01:00:5E:7F:00:10")
      if addr:ismacmcast() then
        print("Is a multicast MAC address")
      end

  ### Return value:

  `true` if the MAC address sets the multicast bit.
cidr:lower (addr)
  Checks whether this CIDR instance is lower than the given argument. The comparisation follows these rules:
  - An IPv4 address is always lower than an IPv6 address and IPv6 addresses are considered lower than MAC addresses
  - Prefix sizes are ignored

  ### Parameters

  - addr: A `luci.ip.cidr` instance or a string convertible by `luci.ip.new()` to compare against.

  ### Usage:

      local addr = luci.ip.new("192.168.1.1")
      print(addr:lower(addr)) -- false
      print(addr:lower("10.10.10.10/24")) -- false
      print(addr:lower(luci.ip.new("::1"))) -- true
      print(addr:lower(luci.ip.new("192.168.200.1"))) -- true
      print(addr:lower(luci.ip.new("00:14:22:01:23:45"))) -- true

  ### Return value:

  `true` if this CIDR is lower than the given address, else `false`.

  ### See also:

  - cidr:higher
  - cidr:equal
cidr:higher (addr)
  Checks whether this CIDR instance is higher than the given argument. The comparisation follows these rules:
  - An IPv4 address is always lower than an IPv6 address and IPv6 addresses are considered lower than MAC addresses
  - Prefix sizes are ignored

  ### Parameters

  - addr: A `luci.ip.cidr` instance or a string convertible by `luci.ip.new()` to compare against.

  ### Usage:

      local addr = luci.ip.new("192.168.1.1")
      print(addr:higher(addr)) -- false
      print(addr:higher("10.10.10.10/24")) -- true
      print(addr:higher(luci.ip.new("::1"))) -- false
      print(addr:higher(luci.ip.new("192.168.200.1"))) -- false
      print(addr:higher(luci.ip.new("00:14:22:01:23:45"))) -- false

  ### Return value:

  `true` if this CIDR is higher than the given address, else `false`.

  ### See also:

  - cidr:lower
  - cidr:equal
cidr:equal (addr)
  Checks whether this CIDR instance is equal to the given argument.

  ### Parameters

  - addr: A `luci.ip.cidr` instance or a string convertible by `luci.ip.new()` to compare against.

  ### Usage:

      local addr = luci.ip.new("192.168.1.1")
      print(addr:equal(addr)) -- true
      print(addr:equal("192.168.1.1")) -- true
      print(addr:equal(luci.ip.new("::1"))) -- false

      local addr6 = luci.ip.new("::1")
      print(addr6:equal("0:0:0:0:0:0:0:1/64")) -- true
      print(addr6:equal(luci.ip.new("fe80::221:63ff:fe75:aa17"))) -- false

      local mac = luci.ip.new("00:14:22:01:23:45")
      print(mac:equal("0:14:22:1:23:45")) -- true
      print(mac:equal(luci.ip.new("01:23:45:67:89:AB")) -- false

  ### Return value:

  `true` if this CIDR is equal to the given address, else `false`.

  ### See also:

  - cidr:lower
  - cidr:higher
cidr:prefix (mask)
  Get or set prefix size of CIDR instance. If the optional mask parameter is given, the prefix size of this CIDR is altered else the current prefix size is returned.

  ### Parameters

  - mask: Either a number containing the number of bits (`0..32` for IPv4, `0..128` for IPv6 or `0..48` for MAC addresses) or a string containing a valid netmask (optional)

  ### Usage:

      local range = luci.ip.new("192.168.1.1/255.255.255.0")
      print(range:prefix()) -- 24

      range:prefix(16)
      print(range:prefix()) -- 16

      range:prefix("255.255.255.255")
      print(range:prefix()) -- 32

  ### Return value:

  Bit count of the current prefix size
cidr:network (mask)
  Derive network address of CIDR instance. Returns a new CIDR instance representing the network address of this instance with all host parts masked out. The used prefix size can be overridden by the optional mask parameter.

  ### Parameters

  - mask: Either a number containing the number of bits (`0..32` for IPv4, `0..128` for IPv6 or `0..48` for MAC addresses) or a string containing a valid netmask (optional)

  ### Usage:

      local range = luci.ip.new("192.168.62.243/255.255.0.0")
      print(range:network())                -- "192.168.0.0"
      print(range:network(24))              -- "192.168.62.0"
      print(range:network("255.255.255.0")) -- "192.168.62.0"

      local range6 = luci.ip.new("fd9b:62b3:9cc5:0:221:63ff:fe75:aa17/64")
      print(range6:network())               -- "fd9b:62b3:9cc5::"

  ### Return value:

  CIDR instance representing the network address
cidr:host ()
  Derive host address of CIDR instance. This function essentially constructs a copy of this CIDR with the prefix size set to `32` for IPv4, `128` for IPv6 or `48` for MAC addresses.

  ### Usage:

      local range = luci.ip.new("172.19.37.45/16")
      print(range)        -- "172.19.37.45/16"
      print(range:host()) -- "172.19.37.45"

  ### Return value:

  CIDR instance representing the host address
cidr:mask (mask)
  Derive netmask of CIDR instance. Constructs a CIDR instance representing the netmask of this instance. The used prefix size can be overridden by the optional mask parameter.

  ### Parameters

  - mask: Either a number containing the number of bits (`0..32` for IPv4, `0..128` for IPv6 or `0..48` for MAC addresses) or a string containing a valid netmask (optional)

  ### Usage:

      local range = luci.ip.new("172.19.37.45/16")
      print(range:mask())            -- "255.255.0.0"
      print(range:mask(24))          -- "255.255.255.0"
      print(range:mask("255.0.0.0")) -- "255.0.0.0"

  ### Return value:

  CIDR instance representing the netmask
cidr:broadcast (mask)
  Derive broadcast address of CIDR instance. Constructs a CIDR instance representing the broadcast address of this instance. The used prefix size can be overridden by the optional mask parameter. This function has no effect on IPv6 or MAC address instances, it will return nothing in this case.

  ### Parameters

  - mask: Either a number containing the number of bits (`0..32` for IPv4) or a string containing a valid netmask (optional)

  ### Usage:

      local range = luci.ip.new("172.19.37.45/16")
      print(range:broadcast())            -- "172.19.255.255"
      print(range:broadcast(24))          -- "172.19.37.255"
      print(range:broadcast("255.0.0.0")) -- "172.255.255.255"

  ### Return value:

  Return a new CIDR instance representing the broadcast address if this instance is an IPv4 range, else return nothing.
cidr:mapped4 ()
  Derive mapped IPv4 address of CIDR instance. Constructs a CIDR instance representing the IPv4 address of the IPv6 mapped IPv4 address in this instance. This function has no effect on IPv4 instances, MAC address instances or IPv6 instances which are not a mapped address, it will return nothing in this case.

  ### Usage:

      local addr = luci.ip.new("::ffff:172.16.19.1")
      print(addr:mapped4()) -- "172.16.19.1"

  ### Return value:

  Return a new CIDR instance representing the IPv4 address if this instance is an IPv6 mapped IPv4 address, else return nothing.
cidr:tomac ()
  Derive MAC address of IPv6 link local CIDR instance. Constructs a CIDR instance representing the MAC address contained in the IPv6 link local address of this instance. This function has no effect on IPv4 instances, MAC address instances or IPv6 instances which are not a link local address, it will return nothing in this case.

  ### Usage:

      local addr = luci.ip.new("fe80::6666:b3ff:fe47:e1b9")
      print(addr:tomac()) -- "64:66:B3:47:E1:B9"

  ### Return value:

  Return a new CIDR instance representing the MAC address if this instance is an IPv6 link local address, else return nothing.
cidr:tolinklocal ()
  Derive IPv6 link local address from MAC address CIDR instance. Constructs a CIDR instance representing the IPv6 link local address of the MAC address represented by this instance. This function has no effect on IPv4 instances or IPv6 instances, it will return nothing in this case.

  ### Usage:

      local mac = luci.ip.new("64:66:B3:47:E1:B9")
      print(mac:tolinklocal()) -- "fe80::6666:b3ff:fe47:e1b9"

  ### Return value:

  Return a new CIDR instance representing the IPv6 link local address.
cidr:contains (addr)
  Test whether CIDR contains given range.

  ### Parameters

  - addr: A `luci.ip.cidr` instance or a string convertible by `luci.ip.new()` to test.

  ### Usage:

      local range = luci.ip.new("10.24.0.0/255.255.0.0")
      print(range:contains("10.24.5.1"))  -- true
      print(range:contains("::1"))        -- false
      print(range:contains("10.0.0.0/8")) -- false

      local range6 = luci.ip.new("fe80::/10")
      print(range6:contains("fe80::221:63f:fe75:aa17/64"))         -- true
      print(range6:contains("fd9b:6b3:c5:0:221:63f:fe75:aa17/64")) -- false

      local intel_macs = luci.ip.MAC("C0:B6:F9:00:00:00/24")
      print(intel_macs:contains("C0:B6:F9:A3:C:11"))  -- true
      print(intel_macs:contains("64:66:B3:47:E1:B9")) -- false

  ### Return value:

  `true` if this instance fully contains the given address else `false`.
cidr:add (amount, inplace)
  Add given amount to CIDR instance. If the result would overflow the maximum address space, the result is set to the highest possible address.

  ### Parameters

  - amount: A numeric value between 0 and 0xFFFFFFFF, a `luci.ip.cidr` instance or a string convertible by `luci.ip.new()`.
  - inplace: If `true`, modify this instance instead of returning a new derived CIDR instance.

  ### Usage:

      local addr = luci.ip.new("192.168.1.1/24")
      print(addr:add(250))           -- "192.168.1.251/24"
      print(addr:add("0.0.99.0"))    -- "192.168.100.1/24"

      addr:add(256, true)            -- true
      print(addr)                    -- "192.168.2.1/24

      addr:add("255.0.0.0", true)    -- false (overflow)
      print(addr)                    -- "255.255.255.255/24

      local addr6 = luci.ip.new("fe80::221:63f:fe75:aa17/64")
      print(addr6:add(256))          -- "fe80::221:63f:fe75:ab17/64"
      print(addr6:add("::ffff:0"))   -- "fe80::221:640:fe74:aa17/64"

      addr6:add(256, true)           -- true
      print(addr6)                   -- "fe80::221:63f:fe75:ab17/64

      addr6:add("ffff::", true)      -- false (overflow)
      print(addr6)                   -- "ffff:ffff:ffff:ffff:ffff:ffff:ffff:ffff/64"

      local mac = luci.ip.new("00:14:22:01:23:45")
      print(mac:add(256))            -- "00:14:22:01:24:45"
      print(mac:add("0:0:0:0:FF:0")  -- "00:14:22:02:22:45"

      mac:add(256, true)             -- true
      print(mac)                     -- "00:14:22:01:24:45"

      mac:add("FF:FF:0:0:0:0", true) -- false (overflow)
      print(mac)                     -- "FF:FF:FF:FF:FF:FF"

  ### Return value:

  - When adding inplace: Return `true` if the addition succeeded or `false` when the addition overflowed.
  - When deriving new CIDR: Return new instance representing the value of this instance plus the added amount or the highest possible address if the addition overflowed the available address space.
cidr:sub (amount, inplace)
  Subtract given amount from CIDR instance. If the result would under, the lowest possible address is returned.

  ### Parameters

  - amount: A numeric value between 0 and 0xFFFFFFFF, a `luci.ip.cidr` instance or a string convertible by `luci.ip.new()`.
  - inplace: If `true`, modify this instance instead of returning a new derived CIDR instance.

  ### Usage:

      local addr = luci.ip.new("192.168.1.1/24")
      print(addr:sub(256))         -- "192.168.0.1/24"
      print(addr:sub("0.168.0.0")) -- "192.0.1.1/24"

      addr:sub(256, true)          -- true
      print(addr)                  -- "192.168.0.1/24

      addr:sub("255.0.0.0", true)  -- false (underflow)
      print(addr)                  -- "0.0.0.0/24

      local addr6 = luci.ip.new("fe80::221:63f:fe75:aa17/64")
      print(addr6:sub(256))        -- "fe80::221:63f:fe75:a917/64"
      print(addr6:sub("::ffff:0")) -- "fe80::221:63e:fe76:aa17/64"

      addr:sub(256, true)          -- true
      print(addr)                  -- "fe80::221:63f:fe75:a917/64"

      addr:sub("ffff::", true)     -- false (underflow)
      print(addr)                  -- "::/64"

      local mac = luci.ip.new("00:14:22:01:23:45")
      print(mac:sub(256))            -- "00:14:22:01:22:45"
      print(mac:sub("0:0:0:0:FF:0")  -- "00:14:22:00:24:45"

      mac:sub(256, true)             -- true
      print(mac)                     -- "00:14:22:01:22:45"

      mac:sub("FF:FF:0:0:0:0", true) -- false (overflow)
      print(mac)                     -- "00:00:00:00:00:00"

  ### Return value:

  - When subtracting inplace: Return `true` if the subtraction succeeded or `false` when the subtraction underflowed.
  - When deriving new CIDR: Return new instance representing the value of this instance minus the subtracted amount or the lowest address if the subtraction underflowed.
cidr:minhost ()
  Calculate the lowest possible host address within this CIDR instance.

  ### Usage:

      local addr = luci.ip.new("192.168.123.56/24")
      print(addr:minhost())  -- "192.168.123.1"

      local addr6 = luci.ip.new("fd9b:62b3:9cc5:0:221:63ff:fe75:aa17/64")
      print(addr6:minhost()) -- "fd9b:62b3:9cc5::1"

      local mac = luci.ip.new("00:14:22:01:22:45/32")
      print(mac:minhost())   -- "00:14:22:01:00:01"

  ### Return value:

  Returns a new CIDR instance representing the lowest host address within this range.
cidr:maxhost ()
  Calculate the highest possible host address within this CIDR instance.

  ### Usage:

      local addr = luci.ip.new("192.168.123.56/24")
      print(addr:maxhost())  -- "192.168.123.254" (.255 is broadcast)

      local addr6 = luci.ip.new("fd9b:62b3:9cc5:0:221:63ff:fe75:aa17/64")
      print(addr6:maxhost()) -- "fd9b:62b3:9cc5:0:ffff:ffff:ffff:ffff"

      local mac = luci.ip.new("00:14:22:01:22:45/32")
      print(mac:maxhost())   -- "00:14:22:01:FF:FF"

  ### Return value:

  Returns a new CIDR instance representing the highest host address within this range.
cidr:string ()
  Convert CIDR instance into string representation. If the prefix size of instance is less than 32 for IPv4, 128 for IPv6 or 48 for MACs, the address is returned in the form "address/prefix" otherwise just "address". It is usually not required to call this function directly as CIDR objects define it as __tostring function in the associated metatable.

  ### Return value:

  Returns a string representing the range or address of this CIDR instance